/* geepro - Willem eprom programmer for linux
 * Copyright (C) 2006 Krzysztof Komarnicki
 * Email: krzkomar@wp.pl
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. See the file COPYING. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gepro.h"
#include "buffer.h"
#include "lang.h"
#include "main.h"
#include "gui.h"

void buffer_alloc(unsigned int size)
{
    if(GET_BUFFER) free(GET_BUFFER);
    if(!(SET_BUFFER((char *)malloc(sizeof(char)*size)))){
	printf(ALLOCATION_ERROR);
	kill_me(NULL,NULL);
    }
    memset( GET_BUFFER, 0, GET_DEV_SIZE );
    SET_BF_SH(0);
    SET_CHECKSUM(0);
    set_viewer_size(GET_DEV_SIZE);
}

void clear_buffer()
{
    memset( GET_BUFFER, 0, GET_DEV_SIZE );
    SET_STATUS(STS_EMPTY);
    stat_rfsh();
}

long calc_checksum(){
    int i;
    long tmp = 0;
    
    for( i = 0; i < GET_DEV_SIZE; i++ ) tmp += BUFFER(i);
    SET_CHECKSUM(tmp);
    return tmp;
}

char write_buffer(unsigned int addr, unsigned char byte)
{
    if(addr >= GET_DEV_SIZE) return -1;
    BUFFER(addr) = byte;
    return 0;
}

int read_buffer(unsigned int addr)
{
    if(addr >= GET_DEV_SIZE) return -1;
    return BUFFER(addr);
}

void checksum(void)
{
//    SET_CHECKSUM(calc_checksum);
}
